var Game1 = function() {
  Game.call(this);

  this.added = 0;
  this.onPlace = 0;
};

var gameProperties = {
    screenWidth: 720,
    screenHeight: 480,
    lifeHeight: 50
};

var states = {
    game: "game",
    round: 1,
    chickenAdded: 0,
    chickenOnPlace: 0
};

var pentagramCircle = {
    startX: gameProperties.screenWidth / 2,
    startY: gameProperties.screenHeight / 2
};

var easings = [Phaser.Easing.Exponential.InOut, Phaser.Easing.Cubic.InOut, Phaser.Easing.Sinusoidal.InOut, Phaser.Easing.Elastic.InOut];

var sprites = [];

Game1.prototype = Object.create(Game.prototype);
Game1.prototype.constructor = Game1;

Game1.prototype.create = function() {
  Game.prototype.create.call(this);

  pentagramCircle.sprite = this.game.add.sprite(pentagramCircle.startX, pentagramCircle.startY, 'magicRift');
  pentagramCircle.sprite.kill();
  pentagramCircle.sprite.anchor.x = 0.5;
  pentagramCircle.sprite.anchor.y = 0.5;

  /////////////////////////////////////////////

  this.timer.start();

  this.song = this.game.add.audio("songChicken");
  this.song.loop = true;
  this.song.play();

  states.chickenAdded = 0;
  states.chickenOnPlace = 0;
  sprites = [];

  for (var i = 0; i <= GameManager.iterations / 3; ++i) {

    var sprite;
    var tween;

    if (i % 2) {
      //+ (gameProperties.screenWidth / (states.round * 4))

      //sprite = this.game.add.sprite(side * (gameProperties.screenWidth / (states.round * 2)), this.game.world.centerY / 2, 'chicken');

      var startPosX = this.game.rnd.integerInRange(pentagramCircle.sprite.width / 2 + pentagramCircle.startX, gameProperties.screenWidth - sprite.width - 40);
      var startPosY = this.game.rnd.integerInRange(40, gameProperties.screenHeight - gameProperties.lifeHeight);

      sprite = this.game.add.sprite(startPosX, startPosY, 'chickenAnimated', 2);
      sprite.anchor.setTo(0.5, 0.5);
      sprite.smoothed = false;
      sprite.anim = sprite.animations.add('chickenest');
      sprite.anim.play(3, true);

      tween = this.game.add.tween(sprite).to({
        x: gameProperties.screenWidth - sprite.width - 40
      }, 1000, easings[this.game.rnd.integerInRange(0, easings.length)], true, 20, 200, true).loop();

    } else {

      //sprite = this.game.add.sprite(side * (gameProperties.screenWidth / (states.round * 2)) + (gameProperties.screenWidth / (states.round * 4)), (this.game.world.centerY + gameProperties.screenHeight) / 2, "button"+i%4);

      //sprite = this.game.add.sprite(side * (gameProperties.screenWidth / (states.round * 2)), (this.game.world.centerY + gameProperties.screenHeight) / 2, 'chicken');

      var startPosX = this.game.rnd.integerInRange(40, (pentagramCircle.startX - pentagramCircle.sprite.width / 2) - 40);
      var startPosY = this.game.rnd.integerInRange(40, gameProperties.screenHeight - gameProperties.lifeHeight);

      sprite = this.game.add.sprite(startPosX, startPosY, 'chickenAnimated', 2);
      sprite.anchor.setTo(0.5, 0.5);
      sprite.smoothed = false;
      sprite.anim = sprite.animations.add('chickenest');
      sprite.anim.play(5, true);

      tween = this.game.add.tween(sprite).to({
        x: (pentagramCircle.startX - pentagramCircle.sprite.width / 2) - 40
      }, 1000, easings[this.game.rnd.integerInRange(0, easings.length)], true, 20, 1000, true).loop();
    }

    states.chickenAdded++;

    sprite.tween = tween;
    sprite.inputEnabled = true;
    sprite.startX = startPosX;
    sprite.starty = startPosY;
    sprite.input.enableDrag();
    sprite.events.onDragStart.add(this.onDragStart, this);
    sprite.events.onDragStop.add(this.onDragStop, this);

    sprites.push(sprite);

  }
};

Game1.prototype.onDragStart = function(sprite) {
    sprite.tween.pause();
};

Game1.prototype.onDragStop =  function(sprite) {

/*    if(!this.checkOverlap(sprite, pentagramCircle.sprite)) {
        var tweensec = this.game.add.tween(sprite).to({x: sprite.startX, y: sprite.startY}, 1000, Phaser.Easing.Linear.none, true);
        tweensec.onComplete.add(function(){
            sprite.tween.resume();
        });
        if (sprite.onPlace){
            --states.chickenOnPlace;
        }
        sprite.onPlace = false;
    } else {
        sprite.onPlace = true;
        ++states.chickenOnPlace;
    }*/
    states.chickenOnPlace=0;
    for (var i=0;i<sprites.length;i++)
    {
      if ((sprites[i].x > 360-120 && sprites[i].x < 360+120) &&
       (sprites[i].y > 240-120 && sprites[i].y < 240+120))
        states.chickenOnPlace++;
    }
    console.log("added"+states.chickenAdded);
    console.log("place"+states.chickenOnPlace);
    if(states.chickenOnPlace === states.chickenAdded) {
        this.youWin();
    }

};

Game1.prototype.checkOverlap = function(spriteA, spriteB) {
    var boundsA = spriteA.getBounds();
    var boundsB = spriteB.getBounds();

    return Phaser.Rectangle.intersects(boundsA, boundsB);
};

Game1.prototype.checkIfWin = function(){
    return states.chickenAdded === states.chickenOnPlace;
};

Game1.prototype.youWin = function(){
  states.chickenAdded = 0;
  states.chickenOnPlace = 0;
  this.onSucces();
};

Game1.prototype.disableChicken = function(){
    for(var i = 0; i < sprites.length; ++i) {
        sprites[i].input.disableDrag();
    }
};
