var Game = function() {
  this.timer = null;
  this.culists = null;
  this.magicCircles = null;
};

Game.prototype.constructor = Game;

Game.prototype.create = function() {
  var element;
  var i;

  this.game.add.tileSprite(0, 0, this.game.width, this.game.height, 'background');

  this.rift = this.game.add.group();
  this.rift.x = this.game.world.centerX;
  this.rift.y = this.game.world.centerY;

  this.grounds = [];
  element = this.rift.create(0, 0, 'magicRift');
  this.grounds.push(element);
  element.anchor.setTo(0.5, 0.5);
  element.frame = 1;

  element = this.rift.create(0, 0, 'magicRift');
  this.grounds.push(element);
  element.anchor.setTo(0.5, 0.5);
  element.frame = 0;
  element.alpha = 1;

  this.game.add.tween(element).to({
    alpha: 0
  }, 1000, Phaser.Easing.Sinusoidal.InOut, true, 0, 1000, true).yoyo(true, 500);

  this.circles = [];
  this.circles.push(this.rift.create(0, -105, 'magicCircle'));
  this.circles.push(this.rift.create(105, 0, 'magicCircle'));
  this.circles.push(this.rift.create(0, 105, 'magicCircle'));
  this.circles.push(this.rift.create(-105, 0, 'magicCircle'));

  for (i = 0; i < this.circles.length; i++) {
    element = this.circles[i];

    element.events.onInputDown.add(function(circle) {
      circle.frame = 0;
    }, this);
    element.events.onInputUp.add(function(circle) {
      circle.frame = 1;
    }, this);
    element.anchor.setTo(0.5, 0.5);
    element.inputEnabled = false;
  }

  this.cultists = this.game.add.group();
  this.cultists.x = this.game.world.centerX;
  this.cultists.y = this.game.height - 40;

  this.dd = [];
  var dddd;

  if (GameManager.lives >= 1) {
    dddd = this.cultists.create(-85, 0, 'cultist');
  }
    this.dd.push(dddd);

  if (GameManager.lives >= 2){
    dddd = this.cultists.create(-30, 0, 'cultist');
    this.dd.push(dddd);
  }

  if (GameManager.lives >= 3){
    dddd = this.cultists.create(30, 0, 'cultist');
    dddd.scale.setTo(-1, 1);
    this.dd.push(dddd);
  }

  if (GameManager.lives >= 4) {
    dddd = this.cultists.create(85, 0, 'cultist');
    dddd.scale.setTo(-1, 1);
    this.dd.push(dddd);
  }

  this.cultists.forEach(function(cultist) {
    cultist.animations.add('adore');
    cultist.animations.play('adore', 2, true);

    cultist.anchor.setTo(0.5, 0.5);
  });

  this.timer = new GameTimer(this.game, 618, 103, 15);
  this.timer.onTimeUp.addOnce(this.onFailure, this);
};

Game.prototype.onFailure = function() {
  this.song.pause();
  this.timer.pause();

  var startPosX = 0;
  var startPosY = 80;

  var sprite = this.game.add.sprite(startPosX, startPosY, 'god', 2);
  sprite.anchor.setTo(0.5, 0.5);
  sprite.smoothed = false;
  sprite.anim = sprite.animations.add('godAnimation');
  sprite.anim.play(3, true);

  var cloud = this.game.add.sprite(startPosX, startPosY + 75, 'cloudAnimated', 6);
  cloud.anchor.setTo(0.5, 0.5);
  cloud.smoothed = false;
  cloud.anim = cloud.animations.add('cloudest');
  cloud.anim.play(8, true);

  tween = this.game.add.tween(sprite).to({
    x: gameProperties.screenWidth - sprite.width - 40
  }, 3000, Phaser.Easing.Linear.In, true);

  tween = this.game.add.tween(cloud).to({
    x: gameProperties.screenWidth - sprite.width - 40
  }, 3000, Phaser.Easing.Linear.In, true);

  this.game.time.events.add(1500, function() {
    this.game.add.audio("godExplosion").play();
    console.log(this.dd);
    this.dd[this.dd.length - 1].visible = false;
  }, this);

  tween.onComplete.add(function() {
    if (!GameManager.processHit())
      return this.game.state.start('transitionOver');

    this.game.state.start('transition', true, false, 'Fail');
  }, this);
};

Game.prototype.onSucces = function() {
  this.song.pause();
  this.game.state.start('transition', true, false, 'Success');
};

Game.prototype.update = function() {};
