var Game2 = function() {
  Game.call(this);

  this.sequence = [];
  this.actual = 0;
  this.count = 0;
  this.now = 0;
  this.started = false;
};

Game2.prototype = Object.create(Game.prototype);
Game2.prototype.constructor = Game2;

Game2.prototype.create = function() {
  var n;
  var i;

  this.song = this.game.add.audio("songGaming");
  this.song.loop = true;
  this.song.play();

  Game.prototype.create.call(this);

  n = (GameManager.iterations / 3) + 1

  this.sequence = [];
  this.actual = 0;
  this.count = 0;
  this.started = false;

  for (i = 0; i < n; i++)
    this.sequence.push(this.game.rnd.integerInRange(0, 3));

  this.disable();

  this.game.time.events.add(2000, function() {
    this.now = this.game.time.now;
    this.started = true;
    this.circles[this.sequence[this.actual]].frame = 1;
  }, this);
};

Game2.prototype.enable = function() {
  var i;

  for (i = 0; i < this.circles.length; i++) {
    this.circles[i].events.onInputUp.add(this.onInputUp, this);
    this.circles[i].inputEnabled = true;
  }
};

Game2.prototype.disable = function() {
  var i;

  for (i = 0; i < this.circles.length; i++) {
    this.circles[i].events.onInputUp.removeAll(this);
    this.circles[i].inputEnabled = false;
  }
};

Game2.prototype.moveSequence = function(circle) {
  var index = this.circles.indexOf(circle);

  circle.frame = 1;

  this.game.time.events.add(400, function() {
    circle.frame = 0;
  }, this);

  return this.sequence[this.count++] === index;
};

Game2.prototype.update = function() {
  var that = this;

  if (this.started && this.game.time.now - this.now > 600) {
    this.now = this.game.time.now;

    that.circles[this.sequence[this.actual++]].frame = 0;

    if (this.actual === this.sequence.length) {
      this.started = false;
      this.timer.start();
      this.enable();
    } else
      this.game.time.events.add(300, function() {
        this.circles[this.sequence[this.actual]].frame = 1;
      }, this);
  }
};

Game2.prototype.onInputUp = function(magicCircle) {
  if (this.moveSequence(magicCircle)) {
    if (this.count === this.sequence.length){
      this.onSucces();
    }

  } else{
    this.onFailure();
  }

};
