var GameTimer = function(game, x, y, time) {
  this.game = game;
  this.timeLeft = time;

  this.counter = game.add.text(x, y, this.timeLeft.toString(), {
    font: '42px "Press Start 2P"',
    fill: '#ffffff',
    align: 'center'
  });
  this.counter.anchor.set(0.5);

  this.timer = new Phaser.Timer(game);
  this.timer.loop(Phaser.Timer.SECOND, this.update, this);
  game.time.add(this.timer);

  this.onTimeUp = new Phaser.Signal();
};

GameTimer.prototype.update = function() {
  this.timeLeft--;

  if (this.timeLeft === 0)
    this.onTimeUp.dispatch();

  this.counter.setText(this.timeLeft.toString());
};

GameTimer.prototype.start = function() {
  this.timer.start();
};

GameTimer.prototype.pause = function() {
  this.timer.pause();
};

GameTimer.prototype.stop = function() {
  this.timer.destroy();
};
