var TransitionOver = function() {
  this.description = '';
};

TransitionOver.prototype.constructor = TransitionOver;

TransitionOver.prototype.init = function(description) {
  this.description = description;
}

TransitionOver.prototype.create = function() {
  var banner;

  this.game.add.tileSprite(0, 0, this.game.width, this.game.height, 'backgroundIntro');

  banner = this.game.add.text(this.game.width / 2, 0, 'Round '+ GameManager.iterations, {
    font: '42px "Press Start 2P"',
    fill: '#000000',
    align: 'center'
  });
  banner.anchor.set(0.5);

  this.song = this.game.add.audio("songBetweenGames");
  this.song.play();

  this.god = this.game.add.sprite(this.game.world.centerX, this.game.world.centerY + 125, 'god', 2);
  this.god.anchor.setTo(0.5, 0.5);
  this.god.smoothed = false;
  this.god.anim = this.god.animations.add('goddest');
  this.god.anim.play(5, true);

  this.cloud = this.game.add.sprite(this.game.world.centerX, this.game.world.centerY + 187, 'cloudAnimated', 6);
  this.cloud.anchor.setTo(0.5, 0.5);
  this.cloud.smoothed = false;
  this.cloud.anim = this.cloud.animations.add('cloudest');
  this.cloud.anim.play(8, true);

  this.dialog = this.game.add.sprite(this.game.world.centerX, this.game.world.centerY, 'dialog');
  this.dialog.anchor.setTo(0.5, 0.5);
  this.dialog.width *= 2;
  this.dialog.height *= 1.5;

  this.nextGame = GameManager.nextState();
  var tutorialText = "Game Over";
  var textX = this.game.world.centerX * 1.5;
  var textY = this.game.world.centerY * 0.9;

  var text = this.game.add.text(textX, textY, tutorialText, {
    font: '22px "Press Start 2P"',
    fill: '#000000',
    align: 'center'
  });

  this.game.add.tween(banner.scale).from({
    x: 0.8,
    y: 0.8
  }, 500, Phaser.Easing.Sinusoidal.InOut, true);

  this.game.add.tween(banner).to({
    alpha: 1,
    y: this.game.height / 2 - 150
  }, 500, Phaser.Easing.Sinusoidal.InOut, true);

  if(GameManager.iterations / 3 <= 1) {
    this.game.time.events.add(3720, this.start, this);
  }else{
    this.game.time.events.add(1720, this.start, this);
  }

};

TransitionOver.prototype.start = function() {
  this.song.pause();
  this.game.state.TransitionOver.to("menu");
};

TransitionOver.prototype.update = function() {

};
